
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import com.github.javacliparser
import java.awt
import javax.swing
import javax.swing.event
import jpype
import moa.options
import typing



class OptionEditComponent:
    def applyState(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class OptionsConfigurationPanel(javax.swing.JPanel):
    FIXED_PANEL_WIDTH: typing.ClassVar[int] = ...
    MAX_PANEL_HEIGHT: typing.ClassVar[int] = ...
    def __init__(self, string: str, options: com.github.javacliparser.Options): ...
    def applyChanges(self) -> None: ...
    @staticmethod
    def getEditComponent(option: com.github.javacliparser.Option) -> javax.swing.JComponent: ...
    def getHelpText(self) -> str: ...
    @staticmethod
    def main(stringArray: typing.Union[typing.List[str], jpype.JArray]) -> None: ...
    def resetToDefaults(self) -> None: ...
    @staticmethod
    def showEditOptionsDialog(component: java.awt.Component, string: str, optionHandler: moa.options.OptionHandler) -> bool: ...
    def showHelpDialog(self) -> None: ...

class ClassOptionEditComponent(javax.swing.JPanel, OptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...
    def addChangeListener(self, changeListener: typing.Union[javax.swing.event.ChangeListener, typing.Callable]) -> None: ...
    def applyState(self) -> None: ...
    def editObject(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def removeChangeListener(self, changeListener: typing.Union[javax.swing.event.ChangeListener, typing.Callable]) -> None: ...
    def setEditState(self, string: str) -> None: ...

class ClassOptionWithNamesEditComponent(javax.swing.JPanel, OptionEditComponent):
    def __init__(self, classOptionWithNames: moa.options.ClassOptionWithNames): ...
    def addChangeListener(self, changeListener: typing.Union[javax.swing.event.ChangeListener, typing.Callable]) -> None: ...
    def applyState(self) -> None: ...
    def editObject(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def removeChangeListener(self, changeListener: typing.Union[javax.swing.event.ChangeListener, typing.Callable]) -> None: ...
    def setEditState(self, string: str) -> None: ...

class FileOptionEditComponent(javax.swing.JPanel, OptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...
    def applyState(self) -> None: ...
    def browseForFile(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class FlagOptionEditComponent(javax.swing.JCheckBox, OptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...
    def applyState(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class FloatOptionEditComponent(javax.swing.JPanel, OptionEditComponent):
    SLIDER_RESOLUTION: typing.ClassVar[int] = ...
    def __init__(self, option: com.github.javacliparser.Option): ...
    def applyState(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class IntOptionEditComponent(javax.swing.JPanel, OptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...
    def applyState(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class MultiChoiceOptionEditComponent(javax.swing.JComboBox[str], OptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...
    def applyState(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class StringOptionEditComponent(javax.swing.JTextField, OptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...
    def applyState(self) -> None: ...
    def getEditedOption(self) -> com.github.javacliparser.Option: ...
    def setEditState(self, string: str) -> None: ...

class ListOptionEditComponent(StringOptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...

class RangeOptionEditComponent(StringOptionEditComponent):
    def __init__(self, option: com.github.javacliparser.Option): ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("com.github.javacliparser.gui")``.

    ClassOptionEditComponent: typing.Type[ClassOptionEditComponent]
    ClassOptionWithNamesEditComponent: typing.Type[ClassOptionWithNamesEditComponent]
    FileOptionEditComponent: typing.Type[FileOptionEditComponent]
    FlagOptionEditComponent: typing.Type[FlagOptionEditComponent]
    FloatOptionEditComponent: typing.Type[FloatOptionEditComponent]
    IntOptionEditComponent: typing.Type[IntOptionEditComponent]
    ListOptionEditComponent: typing.Type[ListOptionEditComponent]
    MultiChoiceOptionEditComponent: typing.Type[MultiChoiceOptionEditComponent]
    OptionEditComponent: typing.Type[OptionEditComponent]
    OptionsConfigurationPanel: typing.Type[OptionsConfigurationPanel]
    RangeOptionEditComponent: typing.Type[RangeOptionEditComponent]
    StringOptionEditComponent: typing.Type[StringOptionEditComponent]
