
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.lang
import jpype
import moa.classifiers.rules.multilabel.core.splitcriteria
import moa.core
import moa.options
import typing



class ICVarianceReduction(moa.options.AbstractOptionHandler, moa.classifiers.rules.multilabel.core.splitcriteria.MultiLabelSplitCriterion):
    def __init__(self): ...
    def getBranchSplitVarianceOutput(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray]) -> typing.MutableSequence[float]: ...
    def getBranchesSplitMerits(self, doubleVectorArray: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray]) -> typing.MutableSequence[float]: ...
    def getDescription(self, stringBuilder: java.lang.StringBuilder, int: int) -> None: ...
    def getMeritOfSplit(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray2: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray]) -> float: ...
    def getRangeOfMerit(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray]) -> float: ...

class WeightedICVarianceReduction(ICVarianceReduction):
    weights: moa.core.DoubleVector = ...
    def __init__(self, doubleVector: moa.core.DoubleVector): ...
    def getDescription(self, stringBuilder: java.lang.StringBuilder, int: int) -> None: ...
    def getMeritOfSplit(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray2: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray]) -> float: ...

class PCTWeightedICVarianceReduction(WeightedICVarianceReduction):
    inputWeights: moa.core.DoubleVector = ...
    targetInputTradeoff: float = ...
    def __init__(self, doubleVector: moa.core.DoubleVector, doubleVector2: moa.core.DoubleVector, double3: float): ...
    @typing.overload
    def getMeritOfSplit(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray2: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray3: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray], doubleVectorArray4: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray]) -> float: ...
    @typing.overload
    def getMeritOfSplit(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray2: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray], doubleVectorArray3: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray4: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray]) -> float: ...
    @typing.overload
    def getMeritOfSplit(self, doubleVectorArray: typing.Union[typing.List[moa.core.DoubleVector], jpype.JArray], doubleVectorArray2: typing.Union[typing.List[typing.MutableSequence[moa.core.DoubleVector]], jpype.JArray]) -> float: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("moa.classifiers.multilabel.core.splitcriteria")``.

    ICVarianceReduction: typing.Type[ICVarianceReduction]
    PCTWeightedICVarianceReduction: typing.Type[PCTWeightedICVarianceReduction]
    WeightedICVarianceReduction: typing.Type[WeightedICVarianceReduction]
