
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import com.github.javacliparser
import com.yahoo.labs.samoa.instances
import java.lang
import java.util
import jpype
import moa.clusterers.outliers
import moa.clusterers.outliers.utils.mtree
import typing



class AbstractCBase(moa.clusterers.outliers.MyBaseOutlierDetector):
    m_nBothInlierOutlier: int = ...
    m_nOnlyInlier: int = ...
    m_nOnlyOutlier: int = ...
    def __init__(self): ...
    def Print_lt_cnt(self, arrayList: java.util.ArrayList[int]) -> None: ...
    def getObjectInfo(self, object: typing.Any) -> str: ...
    def getStatistics(self) -> str: ...

class ISBIndex:
    def __init__(self, double: float, double2: float): ...
    def Insert(self, iSBNode: 'ISBIndex.ISBNode') -> None: ...
    def RangeSearch(self, iSBNode: 'ISBIndex.ISBNode', double: float) -> java.util.Vector['ISBIndex.ISBSearchResult']: ...
    def Remove(self, iSBNode: 'ISBIndex.ISBNode') -> None: ...
    class ISBNode:
        inst: com.yahoo.labs.samoa.instances.Instance = ...
        obj: 'StreamObj' = ...
        id: int = ...
        lt_cnt: java.util.ArrayList = ...
        nOutlier: int = ...
        nInlier: int = ...
        def __init__(self, instance: com.yahoo.labs.samoa.instances.Instance, streamObj: 'StreamObj', long: int): ...
    class ISBSearchResult:
        node: 'ISBIndex.ISBNode' = ...
        distance: float = ...
        def __init__(self, iSBNode: 'ISBIndex.ISBNode', double: float): ...

class StreamObj(moa.clusterers.outliers.utils.mtree.DistanceFunctions.EuclideanCoordinate, java.lang.Comparable['StreamObj']):
    def __init__(self, *double: float): ...
    def compareTo(self, streamObj: 'StreamObj') -> int: ...
    def dimensions(self) -> int: ...
    def equals(self, object: typing.Any) -> bool: ...
    def get(self, int: int) -> float: ...
    def hashCode(self) -> int: ...

class Test:
    def __init__(self): ...
    @staticmethod
    def main(stringArray: typing.Union[typing.List[str], jpype.JArray]) -> None: ...

class AbstractC(AbstractCBase):
    radiusOption: com.github.javacliparser.FloatOption = ...
    kOption: com.github.javacliparser.IntOption = ...
    waitWinFullOption: com.github.javacliparser.FlagOption = ...
    def __init__(self): ...
    def Init(self) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("moa.clusterers.outliers.AbstractC")``.

    AbstractC: typing.Type[AbstractC]
    AbstractCBase: typing.Type[AbstractCBase]
    ISBIndex: typing.Type[ISBIndex]
    StreamObj: typing.Type[StreamObj]
    Test: typing.Type[Test]
