
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import com.github.javacliparser
import java.awt
import java.awt.event
import javax.swing
import jpype
import moa.clusterers
import moa.evaluation
import moa.gui
import moa.gui.visualization
import moa.streams.clustering
import typing



class ClusteringAlgoPanel(javax.swing.JPanel, java.awt.event.ActionListener):
    def __init__(self): ...
    def actionPerformed(self, actionEvent: java.awt.event.ActionEvent) -> None: ...
    def applyChanges(self) -> None: ...
    def getAlgorithm0ValueAsCLIString(self) -> str: ...
    def getAlgorithm1ValueAsCLIString(self) -> str: ...
    def getClusterer0(self) -> moa.clusterers.AbstractClusterer: ...
    def getClusterer1(self) -> moa.clusterers.AbstractClusterer: ...
    def getEditComponent(self, option: com.github.javacliparser.Option) -> javax.swing.JComponent: ...
    def getStream(self) -> moa.streams.clustering.ClusteringStream: ...
    def getStreamValueAsCLIString(self) -> str: ...
    def renderAlgoPanel(self) -> None: ...
    def setAlgorithm0ValueAsCLIString(self, string: str) -> None: ...
    def setAlgorithm1ValueAsCLIString(self, string: str) -> None: ...
    def setPanelTitle(self, string: str) -> None: ...
    def setStreamValueAsCLIString(self, string: str) -> None: ...

class ClusteringEvalPanel(javax.swing.JPanel):
    def __init__(self): ...
    def getSelectedMeasures(self) -> typing.MutableSequence[moa.evaluation.MeasureCollection]: ...

class ClusteringSetupTab(javax.swing.JPanel):
    def __init__(self): ...
    def addButtonActionListener(self, actionListener: typing.Union[java.awt.event.ActionListener, typing.Callable]) -> None: ...
    def getClusterer0(self) -> moa.clusterers.AbstractClusterer: ...
    def getClusterer1(self) -> moa.clusterers.AbstractClusterer: ...
    def getLogPanel(self) -> moa.gui.TextViewerPanel: ...
    def getMeasures(self) -> typing.MutableSequence[moa.evaluation.MeasureCollection]: ...
    def getStream0(self) -> moa.streams.clustering.ClusteringStream: ...
    def stopRun(self) -> None: ...
    def toggleRunMode(self) -> None: ...

class ClusteringTabPanel(moa.gui.AbstractTabPanel):
    def __init__(self): ...
    def getDescription(self) -> str: ...
    def getTabTitle(self) -> str: ...

class ClusteringVisualEvalPanel(javax.swing.JPanel):
    def __init__(self): ...
    def setMeasures(self, measureCollectionArray: typing.Union[typing.List[moa.evaluation.MeasureCollection], jpype.JArray], measureCollectionArray2: typing.Union[typing.List[moa.evaluation.MeasureCollection], jpype.JArray], actionListener: typing.Union[java.awt.event.ActionListener, typing.Callable]) -> None: ...
    @typing.overload
    def update(self, graphics: java.awt.Graphics) -> None: ...
    @typing.overload
    def update(self) -> None: ...

class ClusteringVisualTab(javax.swing.JPanel, java.awt.event.ActionListener):
    def __init__(self): ...
    def actionPerformed(self, actionEvent: java.awt.event.ActionEvent) -> None: ...
    def getEvalPanel(self) -> ClusteringVisualEvalPanel: ...
    def getGraphCanvas(self) -> moa.gui.visualization.GraphCanvas: ...
    def getLeftStreamPanel(self) -> moa.gui.visualization.StreamPanel: ...
    def getPauseInterval(self) -> int: ...
    def getRightStreamPanel(self) -> moa.gui.visualization.StreamPanel: ...
    def isEnabledDrawClustering(self) -> bool: ...
    def isEnabledDrawGroundTruth(self) -> bool: ...
    def isEnabledDrawMicroclustering(self) -> bool: ...
    def isEnabledDrawPoints(self) -> bool: ...
    @typing.overload
    def repaint(self, int: int, int2: int, int3: int, int4: int) -> None: ...
    @typing.overload
    def repaint(self, long: int) -> None: ...
    @typing.overload
    def repaint(self, rectangle: java.awt.Rectangle) -> None: ...
    @typing.overload
    def repaint(self, long: int, int: int, int2: int, int3: int, int4: int) -> None: ...
    @typing.overload
    def repaint(self) -> None: ...
    def setClusteringSetupTab(self, clusteringSetupTab: ClusteringSetupTab) -> None: ...
    def setDimensionComobBoxes(self, int: int) -> None: ...
    def setPauseInterval(self, int: int) -> None: ...
    def setProcessedPointsCounter(self, int: int) -> None: ...
    def stopVisualizer(self) -> None: ...
    def toggleVisualizer(self, boolean: bool) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("moa.gui.clustertab")``.

    ClusteringAlgoPanel: typing.Type[ClusteringAlgoPanel]
    ClusteringEvalPanel: typing.Type[ClusteringEvalPanel]
    ClusteringSetupTab: typing.Type[ClusteringSetupTab]
    ClusteringTabPanel: typing.Type[ClusteringTabPanel]
    ClusteringVisualEvalPanel: typing.Type[ClusteringVisualEvalPanel]
    ClusteringVisualTab: typing.Type[ClusteringVisualTab]
